import React from 'react';

export const renderTemplate = (data) => {
    const components = data.components || data.template.components;
    const inheritedKey = data.key || data.template.key;
    if (components) {
        return components.map((component, componentIndex) => {
            if (component.type && data.atoms[component.type]) {
                const Component = data.atoms[component.type];
                let key = `${component.type}_${componentIndex}`;
                if(inheritedKey) {
                    key = `${inheritedKey}_${key}`;
                }
                if (!component.components || (component.components && component.components.length == 0)) {
                    return (
                        <Component
                            key={key}
                            { ...setupProps(component.props)}
                        />
                    );
                } else {
                    return (
                        <Component
                            key={key}
                            { ...setupProps(component.props)}
                        >
                            {renderTemplate({template: component, atoms: data.atoms, key})}
                        </Component>
                    );
                }
            }
        })
    }
}

export const setupProps = ( props ) => {
    return props;
}